/**
 * Copyright or © or Copr. IETR/INSA - Rennes (2017 - 2019) :
 *
 * Antoine Morvan <antoine.morvan@insa-rennes.fr> (2018 - 2019)
 * Daniel Madroñal <daniel.madronal@upm.es> (2019)
 * Julien Hascoet <jhascoet@kalray.eu> (2017)
 *
 * This software is a computer program whose purpose is to help prototyping
 * parallel applications using dataflow formalism.
 *
 * This software is governed by the CeCILL  license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 */
/*
	============================================================================
	Name        : clock.c
	Author      : mpelcat
	Version     : 1.0
	Copyright   : CECILL-C
	Description : Timing primitive for Preesm Codegen.
	============================================================================
*/

#include "clock.h"

uint64_t startTimes[MAX_STAMPS]; 	/* cycle */
uint64_t elapsedTimes[MAX_STAMPS];	/* cycle */

// Starting to record time for a given stamp
void startTiming(int stamp){
    startTimes[stamp] = __k1_read_dsu_timestamp();
}

// Stoping to record time for a given stamp. Returns the time in us
unsigned int stopTiming(int stamp){
	uint64_t t2 = __k1_read_dsu_timestamp();
    elapsedTimes[stamp] = t2 - startTimes[stamp];
    return (unsigned int)(elapsedTimes[stamp]/(__bsp_frequency/1000000));
}
